package com.ycwl.basic.service.impl.pc;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ycwl.basic.mapper.pc.DeviceMapper;
import com.ycwl.basic.model.pc.device.req.DeviceAddOrUpdateReq;
import com.ycwl.basic.model.pc.device.req.DeviceReqQuery;
import com.ycwl.basic.model.pc.device.resp.DeviceRespVO;
import com.ycwl.basic.service.pc.DeviceService;
import com.ycwl.basic.utils.ApiResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Author：longbinbin
 * @Date：2024/12/2 16:18
 */
@Service
public class DeviceServiceImpl implements DeviceService {
    @Autowired
    private DeviceMapper deviceMapper;
    @Override
    public ApiResponse<PageInfo<DeviceRespVO>> pageQuery(DeviceReqQuery deviceReqQuery) {
        PageHelper.startPage(deviceReqQuery.getPageNum(), deviceReqQuery.getPageSize());
        List<DeviceRespVO> list = deviceMapper.list(deviceReqQuery);
        PageInfo<DeviceRespVO> pageInfo = new PageInfo<>(list);
        return ApiResponse.buildSuccessResponse(pageInfo);
    }

    @Override
    public ApiResponse<List<DeviceRespVO>> list(DeviceReqQuery deviceReqQuery) {
        return ApiResponse.buildSuccessResponse(deviceMapper.list(deviceReqQuery));
    }

    @Override
    public ApiResponse<DeviceRespVO> getById(Long id) {
        return ApiResponse.buildSuccessResponse(deviceMapper.getById(id));
    }

    @Override
    public ApiResponse addOrUpdate(DeviceAddOrUpdateReq deviceReqQuery) {
        Long id = deviceReqQuery.getId();
        if (id == null) {
            return ApiResponse.buildSuccessResponse(deviceMapper.add(deviceReqQuery));
        } else {
            return ApiResponse.buildSuccessResponse(deviceMapper.update(deviceReqQuery));
        }
    }

    @Override
    public ApiResponse deleteById(Long id) {
        return ApiResponse.buildSuccessResponse(deviceMapper.deleteById(id));
    }

    @Override
    public ApiResponse updateStatus(Long id) {
        return ApiResponse.buildSuccessResponse(deviceMapper.updateStatus(id));
    }
}
