package com.ycwl.basic.service.impl.pc;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.ycwl.basic.mapper.pc.FaceSampleMapper;
import com.ycwl.basic.model.pc.face.entity.FaceEntity;
import com.ycwl.basic.model.pc.face.req.FaceReqQuery;
import com.ycwl.basic.model.pc.face.resp.FaceRespVO;
import com.ycwl.basic.model.pc.faceSample.entity.FaceSampleEntity;
import com.ycwl.basic.model.pc.faceSample.req.FaceSampleReqQuery;
import com.ycwl.basic.model.pc.faceSample.resp.FaceSampleRespVO;
import com.ycwl.basic.service.pc.FaceSampleService;
import com.ycwl.basic.service.pc.FaceService;
import com.ycwl.basic.utils.ApiResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @Author：longbinbin
 * @Date：2024/12/2 16:39
 */
@Service
public class FaceSampleServiceImpl implements FaceSampleService {
    @Autowired
    private FaceSampleMapper faceSampleMapper;

    @Override
    public ApiResponse<PageInfo<FaceSampleRespVO>> pageQuery(FaceSampleReqQuery faceSampleReqQuery) {
        PageHelper.startPage(faceSampleReqQuery.getPageNum(),faceSampleReqQuery.getPageSize());
        List<FaceSampleRespVO> list = faceSampleMapper.list(faceSampleReqQuery);
        PageInfo<FaceSampleRespVO> pageInfo = new PageInfo<>(list);
        return ApiResponse.buildSuccessResponse(pageInfo);
    }

    @Override
    public ApiResponse<List<FaceSampleRespVO>> list(FaceSampleReqQuery faceSampleReqQuery) {
        return ApiResponse.buildSuccessResponse(faceSampleMapper.list(faceSampleReqQuery));
    }

    @Override
    public ApiResponse<FaceSampleRespVO> getById(Long id) {
        return ApiResponse.buildSuccessResponse(faceSampleMapper.getById(id));
    }

    @Override
    public ApiResponse<Integer> add(FaceSampleEntity faceSample) {
        int i = faceSampleMapper.add(faceSample);
        if (i == 0) {
            return ApiResponse.buildCommonErrorResponse("添加失败");
        }
        return ApiResponse.buildSuccessResponse(i);
    }

    @Override
    public ApiResponse<Integer> deleteById(Long id) {
        int i = faceSampleMapper.deleteById(id);
        if (i == 0) {
            return ApiResponse.buildCommonErrorResponse("删除失败");
        }
        return ApiResponse.buildSuccessResponse(i);
    }

    @Override
    public ApiResponse<Integer> deleteByIds(List<Long> ids) {
        int i = faceSampleMapper.deleteByIds(ids);
        if (i == 0) {
            return ApiResponse.buildCommonErrorResponse("删除失败");
        }
        return ApiResponse.buildSuccessResponse(i);
    }

    @Override
    public ApiResponse<Integer> update(FaceSampleEntity faceSample) {
        int i = faceSampleMapper.update(faceSample);
        if (i == 0) {
            return ApiResponse.buildCommonErrorResponse("修改失败");
        }
        return ApiResponse.buildSuccessResponse(i);
    }
}
